------------------------------------------------------------------------------
--
-- Filename:                guard_mx.vhd
-- Inhalt:                  Multiplexer mit guarded signals
--                          Verwendet fourval.vhd (zuerst uebersetzen!)
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        10.02.94
--
------------------------------------------------------------------------------

USE work.fourval.ALL;

ENTITY mux_2_1 IS

  PORT (in_signals : IN  mvl4_vector (1 TO 2);
        choice     : IN  integer;
        out_signal : OUT mvl4_r BUS );

END mux_2_1;

------------------------------------------------------------------------------

ARCHITECTURE with_guards OF mux_2_1 IS

  DISCONNECT out_signal : mvl4_r AFTER 25 ns;

BEGIN

  choice_1 : BLOCK (choice = 1)
  BEGIN
    out_signal <= GUARDED in_signals(1) AFTER 20 ns;
  END BLOCK;

  choice_2 : BLOCK (choice = 2)
  BEGIN
    out_signal <= GUARDED in_signals(2) AFTER 18 ns;
  END BLOCK;

END with_guards;

