------------------------------------------------------------------------------
--
-- Filename:                ha.vhd
-- Inhalt:                  Beispiel fuer Konfiguration eines strukturalen 
--                          Modells: Halbaddierer
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        03.02.94
--
------------------------------------------------------------------------------

ENTITY halfadder IS

  PORT (sum_a, sum_b : IN bit; sum, carry : OUT bit ) ;
  
END halfadder ;

------------------------------------------------------------------------------

ARCHITECTURE structural OF halfadder IS

  -- Komponentendeklarationen
  COMPONENT xor2
    PORT (c1, c2 : IN bit; c3 : OUT bit) ;
  END COMPONENT ;

  COMPONENT and2
    PORT (c4, c5 : IN bit; c6 : OUT bit) ;
  END COMPONENT ;

BEGIN

  -- Komponenteninstantiierungen
  xor_instance : xor2 PORT MAP (sum_a, sum_b, sum) ;
  and_instance : and2 PORT MAP (sum_a, sum_b, carry) ;

END structural ;

------------------------------------------------------------------------------

CONFIGURATION ha_config OF halfadder IS

  FOR structural
    FOR xor_instance : xor2 USE ENTITY work.exor (behavioral)
      PORT MAP (c1,c2,c3) ;
    END FOR ;

    FOR and_instance : and2 USE CONFIGURATION work.and2_config
      PORT MAP (a => c4, b => c5, y => c6) ;
    END FOR ;
  END FOR ;

END ha_config ;

 

