------------------------------------------------------------------------------
--
-- Filename:                latch93.vhd
-- Inhalt:                  Verhaltensmodell eines D-Latches mit verschiedenen 
--                          Architekturen (hier: Syntax VHDL93)
--
-- !!! ACHTUNG !!!          verwendet Elemente der Syntax VHDL`93
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        02.02.94
--
------------------------------------------------------------------------------

ENTITY latch IS

  PORT (d, clk : IN bit; q : OUT bit) ;  -- hier genuegt OUT, da q nicht
                                         -- gelesen wird   
END latch ;


------------------------------------------------------------------------------
--
-- concurrent_3: Verwendung von "conditional signal assignment"
--
------------------------------------------------------------------------------

ARCHITECTURE concurrent_3 OF latch IS   -- !! VHDL93-Syntax !!

BEGIN

  q <= d WHEN clk = '1' ELSE UNAFFECTED ;

END concurrent_3 ;


------------------------------------------------------------------------------
--
-- concurrent_4: Verwendung von "selected signal assignment"
--
------------------------------------------------------------------------------

ARCHITECTURE concurrent_4 OF latch IS   -- !! VHDL93-Syntax !!

BEGIN

  WITH clk select
    q <= d WHEN '1' ,
         UNAFFECTED WHEN OTHERS ;

END concurrent_4 ;

