------------------------------------------------------------------------------
--
-- Filename:                shift_l.vhd
-- Inhalt:                  Beispiel fuer LOOP-Anweisungen
--                          Rotieren des Eingangsvektors in_table
--                          um n Stellen nach links, Ausgabe ueber
--                          out_table
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        06.03.94
--
------------------------------------------------------------------------------

ENTITY n_time_left_shift IS

  GENERIC (n : natural := 2) ;                    -- Anzahl der Stellen
  PORT (in_table  : IN  bit_vector (0 TO 31);
	out_table : OUT bit_vector (0 TO 31)) ;
   
END n_time_left_shift ;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF n_time_left_shift IS

BEGIN

  PROCESS (in_table)

    VARIABLE count : natural ;
    VARIABLE table : bit_vector (0 TO 32) ;       -- zusaetzliches Bit 

  BEGIN

    count := 0 ;
    table(0 TO 31) := in_table ;

    n_time_loop : WHILE count < n LOOP
      count := count + 1 ;
      table(table'HIGH) := table(table'LOW) ;
      left_shift_loop : FOR j IN table'LOW TO table'HIGH - 1 LOOP
        table(j) := table(j+1) ;
      END LOOP ;
    END LOOP n_time_loop ;

    out_table <= table(0 TO 31);

  END PROCESS ;

END behavioral ;

