------------------------------------------------------------------------------
--
-- Filename:                write.vhd
-- Inhalt:                  Beispiel zum typspezifischen File I/O
--                          Aenderungen des Eingangssignals data_8
--                          werden bis zum Zeitpunkt 100 ns auf
--                          die Datei data_8.out geschrieben.
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder, Gunther Lehmann 
-- Letzte Aenderung:        06.03.94
--
------------------------------------------------------------------------------

PACKAGE memory_types IS

  SUBTYPE byte IS bit_vector(0 TO 7);

END memory_types;

------------------------------------------------------------------------------

USE work.memory_types.ALL;

ENTITY write_data IS

  PORT (data_8 : IN byte);

END write_data;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF write_data IS

BEGIN

  write_process: PROCESS

    TYPE byte_file IS FILE OF work.memory_types.byte; 
    FILE output : byte_file IS OUT "data_8.out";     

  BEGIN

    WAIT on data_8;              -- Warten auf Aenderungen von data_8
    IF NOW <= 100 ns THEN
      write (output, data_8);    -- Schreiben eines Signalwertes
      ASSERT false REPORT "New value written" SEVERITY note;
    ELSE
      WAIT;                      -- Warte "fuer immer" 
    END IF;

  END PROCESS;

END behavioral;

