------------------------------------------------------------------------------
--
-- Filename:            dff_res.vhd
-- Inhalt:              Modellierungsbeispiel
--                      eines D-Flip-Flops mit Reset
--
------------------------------------------------------------------------------
--
-- Autor:               Manfred Selz
-- Letzte Aenderung:    16.02.1994
--
------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY dff IS

  PORT (clk,d,reset: IN  std_ulogic;
        q:           OUT std_ulogic);

END dff;

------------------------------------------------------------------------------

ARCHITECTURE async_reset OF dff IS

BEGIN

  PROCESS (clk,reset)
  BEGIN

    -- low-aktives Reset hat erste Prioritaet
    IF (reset='0') THEN
      q <= '0';

    -- Abfrage auf Taktflanke nur, wenn kein Reset
    ELSIF (clk'EVENT AND clk='1') THEN
      q <= d;
    END IF;
  END PROCESS;

END async_reset;


