------------------------------------------------------------------------------
--
-- Filename:            if_case.vhd
-- Inhalt:              Vergleich von IF- und CASE-Anweisung
--
------------------------------------------------------------------------------
--
-- Autor:               Manfred Selz
-- Letzte Aenderung:    16.02.1994
--
------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY if_und_case IS

  PORT (i:     IN  INTEGER RANGE 0 TO 9;
        a,b,c: IN  std_ulogic_vector (7 DOWNTO 0);
        z:     OUT std_ulogic_vector (7 DOWNTO 0));

END if_und_case;

------------------------------------------------------------------------------

ARCHITECTURE if_variante OF if_und_case IS

BEGIN

  p1: PROCESS (i,a,b,c)
  BEGIN
    -- erste Abfrage hat Prioritaet
    IF    (i = 3) THEN z <= a;
    ELSIF (i < 3) THEN z <= b;
    ELSE               z <= c;
    END IF;
  END PROCESS p1;

END if_variante;

------------------------------------------------------------------------------

ARCHITECTURE case_variante OF if_und_case IS

BEGIN

  p1: PROCESS (i,a,b,c)
  BEGIN
    -- alle Zweige sind gleichwertig
    CASE i IS
      WHEN 3      => z <= a;
      WHEN 0 TO 2 => z <= b;
      WHEN OTHERS => z <= c;
    END CASE;
  END PROCESS p1;

END case_variante;

