------------------------------------------------------------------------------
--
-- Filename:            tff.vhd
-- Inhalt:              Modellierungsbeispiel eines Toggle-Flip-Flops
--
------------------------------------------------------------------------------
--
-- Autor:               Manfred Selz
-- Letzte Aenderung:    16.02.1994
--
------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY t_ff IS

  PORT (clk,enable : IN  std_ulogic;
        q          : BUFFER std_ulogic := '0');

END t_ff;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF t_ff IS

BEGIN

  PROCESS
  BEGIN

    -- WAIT UNTIL clk'EVENT AND clk='1' AND clk'LAST_VALUE='0'; 
    -- meist nicht fuer Synthese geeignet

    WAIT UNTIL clk'EVENT AND clk='1';
 
    -- toggle if enable is active

    IF enable ='1' THEN q <= NOT q;
    END IF;
  END PROCESS;

END behavioral;

