------------------------------------------------------------------------------
--
-- Filename:                not1_tb.vhd
-- Inhalt:                  Testbench fuer den Inverter not1.vhd
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder  
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

LIBRARY    ieee;
USE        ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY not1_tb IS

END not1_tb;

------------------------------------------------------------------------------

ARCHITECTURE arch_1 OF not1_tb IS

    SIGNAL i,y : std_ulogic;

    COMPONENT not1
        PORT (x1 : IN  std_ulogic; 
              x2 : OUT std_ulogic);
    END COMPONENT;

BEGIN

    model_under_test : not1 PORT MAP (i,y);     -- Instanz MUT

    PROCESS
    BEGIN
        i <= '0' AFTER  0 ns,                   -- Stimuli
             '1' AFTER  5 ns,
             'X' AFTER 10 ns,
             '1' AFTER 15 ns,
             '0' AFTER 20 ns;    
                                                -- erwartete Antworten: 
                                                -- pruefe 1 ns nach Stimuli

        WAIT FOR  1 ns; ASSERT (y = '1') REPORT "y isn't 1" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = 'X') REPORT "y isn't X" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '0') REPORT "y isn't 0" SEVERITY failure;
        WAIT FOR  5 ns; ASSERT (y = '1') REPORT "y isn't 1" SEVERITY failure;

        WAIT;                                   -- Ende der Simulation

    END PROCESS;

END arch_1;

------------------------------------------------------------------------------

CONFIGURATION not1_tb_config OF not1_tb IS

    FOR arch_1
        FOR model_under_test: not1 USE ENTITY work.not1 (behavioral)
            GENERIC MAP (tp_lh=>0.8 ns, tp_hl=> 0.7 ns)
            PORT MAP (a=>x1, y=>x2);
        END FOR;
    END FOR;

END not1_tb_config;
