------------------------------------------------------------------------------
--
-- Filename:                bcd_7seg.vhd
-- Inhalt:                  Codierer
--                          Eingang: BCD-Zahl (Zahlen 0-9 binaer) 
--                          Ausgang: Ansteuerung 7 Segment-Anzeige
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann
-- Letzte Aenderung:        07.02.94
--
------------------------------------------------------------------------------

ENTITY bcd_7seg IS
	PORT( bcd: IN bit_vector (0 TO 3);
			a,b,c,d,e,f,g: OUT bit);
END bcd_7seg;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF bcd_7seg IS
	SUBTYPE seg IS bit_vector(1 TO 7);
BEGIN
    PROCESS ( bcd )
    BEGIN
	CASE bcd IS
		WHEN "0000" => (a,b,c,d,e,f,g) <= seg'(b"111_111_0");
		WHEN "0001" => (a,b,c,d,e,f,g) <= seg'(b"011_000_0");
		WHEN "0010" => (a,b,c,d,e,f,g) <= seg'(b"110_110_1");
		WHEN "0011" => (a,b,c,d,e,f,g) <= seg'(b"111_100_1");
		WHEN "0100" => (a,b,c,d,e,f,g) <= seg'(b"011_001_1");

		WHEN "0101" => (a,b,c,d,e,f,g) <= seg'(b"101_101_1");
		WHEN "0110" => (a,b,c,d,e,f,g) <= seg'(b"001_111_1");
		WHEN "0111" => (a,b,c,d,e,f,g) <= seg'(b"111_000_0");
		WHEN "1000" => (a,b,c,d,e,f,g) <= seg'(b"111_111_1");
		WHEN "1001" => (a,b,c,d,e,f,g) <= seg'(b"111_001_1");

		WHEN OTHERS => (a,b,c,d,e,f,g) <= seg'(b"000_000_0"); 
                -- anzeige dunkel
	END CASE;
    END PROCESS;
END behavioral;

		
